summaryrefslogtreecommitdiffstats
path: root/tqtinterface/qt4/config.tests/x11/xcursor.test
diff options
context:
space:
mode:
Diffstat (limited to 'tqtinterface/qt4/config.tests/x11/xcursor.test')
-rwxr-xr-xtqtinterface/qt4/config.tests/x11/xcursor.test92
1 files changed, 92 insertions, 0 deletions
diff --git a/tqtinterface/qt4/config.tests/x11/xcursor.test b/tqtinterface/qt4/config.tests/x11/xcursor.test
new file mode 100755
index 0000000..0f8a71e
--- /dev/null
+++ b/tqtinterface/qt4/config.tests/x11/xcursor.test
@@ -0,0 +1,92 @@
+#!/bin/sh
+
+XCURSOR=yes
+XCONFIG=$1/qmake.conf
+VERBOSE=$2
+shift 2
+IN_LIBDIRS=""
+IN_INCDIRS=""
+PARAMS=$@
+for PARAM in $PARAMS; do
+ PREFIX=`echo $PARAM | sed 's/^\(..\).*/\1/'`
+ case $PREFIX in
+ -L)
+ CLIBDIR=`echo $PARAM | sed -e 's/^-L//'`
+ IN_LIBDIRS="$IN_LIBDIRS $CLIBDIR"
+ ;;
+ -I)
+ CINCDIR=`echo $PARAM | sed -e 's/^-I//'`
+ IN_INCDIRS="$IN_INCDIRS $CINCDIR"
+ ;;
+ *) ;;
+ esac
+done
+
+# debuggery
+[ "$VERBOSE" = "yes" ] && echo "Xcursor auto-detection... ($*)"
+
+# check for the Xcursor library
+XDIRS=`sed -n -e '/^QMAKE_LIBDIR_X11[ ]*=/ { s/[^=]*=[ ]*//; s/-L/ /g; p; }' $XCONFIG`
+LIBDIRS="$IN_LIBDIRS $XDIRS /usr/shlib /usr/lib /lib"
+F=
+for LIBDIR in $LIBDIRS; do
+ FOUND_LIB=`ls $LIBDIR/libXcursor.* 2>/dev/null`
+ if [ ! -z "$FOUND_LIB" ]; then
+ F=yes
+ [ "$VERBOSE" = "yes" ] && echo " Found Xcursor lib in $LIBDIR"
+ break
+ fi
+done
+if [ -z "$F" ]; then
+ XCURSOR=no
+ [ "$VERBOSE" = "yes" ] && echo " Could not tqfind Xcursor lib anywhere in $LIBDIRS"
+fi
+
+# check for Xcursor.h
+XCURSOR_H=
+if [ "$XCURSOR" = "yes" ]; then
+ INC="X11/Xcursor/Xcursor.h"
+ XDIRS=`sed -n -e '/^QMAKE_INCDIR_X11[ ]*=/ { s/[^=]*=[ ]*//; s/-I/ /g; p; }' $XCONFIG`
+ INCDIRS="$IN_INCDIRS $XDIRS /usr/include /include"
+ F=
+ for INCDIR in $INCDIRS; do
+ if [ -f $INCDIR/$INC ]; then
+ F=yes
+ XCURSOR_H=$INCDIR/$INC
+ [ "$VERBOSE" = "yes" ] && echo " Found $INC in $INCDIR"
+ break
+ fi
+ done
+ if [ -z "$F" ]
+ then
+ XCURSOR=no
+ [ "$VERBOSE" = "yes" ] && echo " Could not tqfind $INC anywhere in $INCDIRS"
+ fi
+fi
+
+# verify that we are using Xcursor 1.x
+if [ "$XCURSOR" = "yes" ]; then
+ XCURSOR_MAJOR=`egrep 'XCURSOR(_LIB)?_MAJOR' $XCURSOR_H | head -n 1 | awk '{ print \$3 }'`
+ XCURSOR_MINOR=`egrep 'XCURSOR(_LIB)?_MINOR' $XCURSOR_H | head -n 1 | awk '{ print \$3 }'`
+ if [ -z "$XCURSOR_MAJOR" -o -z "$XCURSOR_MINOR" ]; then
+ XCURSOR=no
+ [ "$VERBOSE" = "yes" ] && \
+ echo " Could not tqfind Xcursor version."
+ elif [ "$XCURSOR_MAJOR" != "1" ]; then
+ XCURSOR=no
+ [ "$VERBOSE" = "yes" ] && \
+ echo " Found Xcursor version $XCURSOR_MAJOR.$XCURSOR_MINOR, version 1.0 or higher required."
+ else
+ [ "$VERBOSE" = "yes" ] && \
+ echo " Found Xcursor version $XCURSOR_MAJOR.$XCURSOR_MINOR"
+ fi
+fi
+
+# done
+if [ "$XCURSOR" != "yes" ]; then
+ [ "$VERBOSE" = "yes" ] && echo "Xcursor disabled."
+ exit 0
+else
+ [ "$VERBOSE" = "yes" ] && echo "Xcursor enabled."
+ exit 1
+fi